#define INIT /* initialize variables in header files in this module */
#define STRICT

#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "icapismp.h"
#include "icapiloc.h"
#include "ICAPI.H"

/**************************************************************************
* Global macros and variables
**************************************************************************/

#define WC_MAINWINDOW 	"ICAPISampleAppWndClass"
#define WC_EDIT			"Edit"
#define WC_STATIC		"Static"

#define WS_EDITSINGLELINE 	(WS_CHILD | WS_BORDER | ES_AUTOHSCROLL)
#define WS_EDITMULTILINE 	(WS_CHILD | WS_BORDER | ES_MULTILINE  )
//#define WS_EDIT 	(WS_CHILD | WS_BORDER)
//#define WS_EDIT 	(WS_CHILD | WS_BORDER | ES_AUTOHSCROLL)
// #define WS_EDIT 	(WS_CHILD | WS_BORDER) /* | WS_TABSTOP | ES_AUTOHSCROLL | ES_AUTOVSCROLL) */
#define WS_STATIC 	(WS_CHILD | SS_RIGHT)

#ifndef NO_ERROR
    #define NO_ERROR		0x0000
	#endif

#define APIRET			unsigned long

#define MAXSTRLEN		WPICAPI_MAX_STRING_LENGTH

#define APIFILENAME	"ICAPI.DAT"
#define DELIMITER	","
#define ESCCHAR		"\x1B"

WPICAPISETTINGS Settings = {sizeof(WPICAPISETTINGS)
						   ,WPICAPI_MAX_STRING_LENGTH
						   ,WPICAPI_SETTINGS_DEFAULT, 0,0
						   ,DELIMITER
						   ,""};

char BadAllocStr[50] = "Point here if malloc fails";

HANDLE 		GhInst;
int 		GnCmdShow;
HWND		GhWndMain;

typedef struct _tagSUBCLASSINFO
	{
	WNDPROC			Proc;
	} SUBCLASSINFO;

typedef struct _tagMDTWINDOWINFO	
	{
	RECT 			Rect;
	HGLOBAL			hMem;
	char far *		Value;
	DWORD			MaxLen;
	char 			Class[10];
	DWORD 			Style;
	HWND 			hWnd;
	SUBCLASSINFO	BaseClass;
	} MDTWINDOWINFO;

typedef struct _tagMDTDIALOG
	{
	int				NumControls;
	SUBCLASSINFO	Parent;
	MDTWINDOWINFO * pWndInfo;
	int				WndFocusIdx;
	} MDTDIALOG;


#define PROMPT1	 		0
#define PROMPT2	 		1
#define PROMPT3	 		2
#define PROMPT4	 		3
#define PROMPT5	 		4
#define PROMPT6	 		5
#define PROMPT7	 		6
#define PROMPT8	 		7
#define PROMPTRC		8
#define RCVALUE         9

#define BASEEDIT 		10
#define NUMEDIT			9
#define EDIT1	 		(BASEEDIT + 0)
#define EDIT2	 		(BASEEDIT + 1)
#define EDIT3 			(BASEEDIT + 2)
#define EDIT4 			(BASEEDIT + 3)
#define EDIT5			(BASEEDIT + 4)
#define EDIT6			(BASEEDIT + 5)
#define EDIT7			(BASEEDIT + 6)
#define EDIT8   		(BASEEDIT + 7)
#define EDIT9     		(BASEEDIT + 8)

MDTWINDOWINFO DlgWindowInfo[]
	= {
	   {{ 01, 10,190, 27}, 0, NULL, 0,WC_STATIC, WS_STATIC			,NULL}
	  ,{{ 01, 40,190, 27}, 0, NULL, 0,WC_STATIC, WS_STATIC			,NULL}
	  ,{{ 01, 70,190, 27}, 0, NULL, 0,WC_STATIC, WS_STATIC			,NULL}
	  ,{{ 01,100,190, 27}, 0, NULL, 0,WC_STATIC, WS_STATIC			,NULL}
	  ,{{ 01,130,190, 27}, 0, NULL, 0,WC_STATIC, WS_STATIC			,NULL}
	  ,{{ 01,160,190, 27}, 0, NULL, 0,WC_STATIC, WS_STATIC			,NULL}
	  ,{{ 01,190,190, 27}, 0, NULL, 0,WC_STATIC, WS_STATIC			,NULL}
	  ,{{ 01,350,190, 27}, 0, NULL, 0,WC_STATIC, WS_STATIC          ,NULL}

	  ,{{ 01,510,190, 27}, 0, NULL, 0,WC_STATIC, WS_STATIC          ,NULL}
	  ,{{200,510,190, 27}, 0, NULL, 0,WC_STATIC, WS_STATIC          ,NULL}

	  ,{{200, 10,300, 27}, 0, NULL, 0,WC_EDIT  , WS_EDITSINGLELINE  ,NULL}
	  ,{{200, 40,300, 27}, 0, NULL, 0,WC_EDIT  , WS_EDITSINGLELINE  ,NULL}
	  ,{{200, 70,300, 27}, 0, NULL, 0,WC_EDIT  , WS_EDITSINGLELINE  ,NULL}
	  ,{{200,100,300, 27}, 0, NULL, 0,WC_EDIT  , WS_EDITSINGLELINE  ,NULL}
	  ,{{200,130,148, 27}, 0, NULL, 0,WC_EDIT  , WS_EDITSINGLELINE  ,NULL}
	  ,{{352,130,148, 27}, 0, NULL, 0,WC_EDIT  , WS_EDITSINGLELINE  ,NULL}
	  ,{{200,160,300, 27}, 0, NULL, 0,WC_EDIT  , WS_EDITSINGLELINE  ,NULL}
	  ,{{200,190,400,157}, 0, NULL, 0,WC_EDIT  , WS_EDITMULTILINE   ,NULL}
	  ,{{200,350,400,157}, 0, NULL, 0,WC_EDIT  , WS_EDITMULTILINE   ,NULL}
	  }
	  ;

MDTDIALOG Dlg
	= { sizeof(DlgWindowInfo) / sizeof(MDTWINDOWINFO)
	  , {(WNDPROC) NULL}
	  , &DlgWindowInfo[0]
	  , BASEEDIT
	  }
	  ;


/**************************************************************************
* Prototypes
**************************************************************************/

long SYSAPI MainWndProc(HWND hWnd
                                    ,UINT message
									,WPARAM wParam
									,LPARAM lParam
									);

/****************************************************************************
*
*   FUNCTION: InitApplication(HANDLE)
*
*   PURPOSE: Register window class(es)
*
****************************************************************************/

// #pragma argsused
BOOL InitApplication(HANDLE hInstance, int nCmdShow)
	{
    WNDCLASS  wc;

	if (nCmdShow) { }
    /*---------------------------------------------------------------------
    * Register the main window class
    *--------------------------------------------------------------------*/
    wc.style 			= CS_VREDRAW | CS_HREDRAW;
    wc.lpfnWndProc 		= MainWndProc;
    wc.cbClsExtra 		= 0;
    wc.cbWndExtra 		= 0;
    wc.hInstance 		= hInstance;
    wc.hIcon 			= LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor 			= LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground 	= (HBRUSH) COLOR_WINDOW;
    wc.lpszMenuName  	= "ICAPISampleAppMenu";
    wc.lpszClassName 	= WC_MAINWINDOW;

    if (RegisterClass(&wc) == FALSE)
		{
		return(FALSE);
		}

	return(TRUE);
	}

/****************************************************************************
*
*   FUNCTION: WinMain(HANDLE, HANDLE, LPSTR, int)
*
*   PURPOSE: Windows entry point.
*            Calls initialization function, processes message loop.
*
****************************************************************************/
// #pragma argsused
int PASCAL WinMain( HINSTANCE 	hInstance,
					HINSTANCE 	hPrevInstance,
					LPSTR 		lpCmdLine,
					int 		nCmdShow)
	{
    MSG 	Msg;
	HMENU	hMenu = NULL;
	static	char ICAPIModuleName[_MAX_PATH];

	if (lpCmdLine) { }
    GhInst 		= hInstance;
	GnCmdShow 	= nCmdShow;

    /*---------------------------------------------------------------------
    * Initialize application
    *--------------------------------------------------------------------*/
    if (!hPrevInstance)
		{
		if (!InitApplication(GhInst, nCmdShow))
			return (FALSE);
		}

    /*---------------------------------------------------------------------
    * Create the main application window.
    *--------------------------------------------------------------------*/
	//hMenu = LoadMenu(GhInst, "ICAPISampleAppMenu");

	GhWndMain = CreateWindow(WC_MAINWINDOW,
						"InfoCentral API Sample Application",
						WS_OVERLAPPEDWINDOW | WS_VISIBLE, 0, 0, 620, 600,
						HWND_DESKTOP,
						hMenu,
						GhInst,
						NULL
					   );

	WPICAPILocateModule((LPSTR)"WIN32", (LPSTR)"2x", (LPSTR)"US", (LPSTR)ICAPIModuleName, sizeof(ICAPIModuleName));
	
    /*---------------------------------------------------------------------
    * Process messages for the application
    *--------------------------------------------------------------------*/
    while (GetMessage(&Msg, 0, 0, 0))
		{
        TranslateMessage(&Msg);
        DispatchMessage(&Msg);
		}

    return (Msg.wParam);
	}

/***************************************************************************/
APIRET	NextControl(HWND hWndRelated,  HWND * phWnd, UINT fRelationship
					, char * pControlName)
	{
	char			ClassName[20];
	HWND			hWndPrev		= 0;
	BOOL			Found 			= FALSE;
	HWND			hWndSaved 		= *phWnd;
	int				iClassLength	= 0;

	*phWnd = hWndRelated;
	while ((!Found) && (*phWnd != hWndPrev) && (*phWnd != 0))
		{
		hWndPrev = *phWnd;
		*phWnd = GetWindow(*phWnd, fRelationship);
		if (pControlName == NULL)
			{
			Found = TRUE;
			}
		else
			{
			if (*phWnd)
				iClassLength = GetClassName(*phWnd, ClassName, sizeof(ClassName));
			if ((stricmp(ClassName, pControlName) == 0) && (iClassLength))
				{
				Found = TRUE;
				}
			else
				{
				switch (fRelationship)
					{
					case GW_CHILD:
					case GW_HWNDFIRST:
						fRelationship = GW_HWNDNEXT;
						break;
	
					case GW_HWNDLAST:
						fRelationship = GW_HWNDPREV;
						break;
	
					} /* switch */
				} /* else */
			} /* else */
		} /* while */

	if (Found)
		{
		return(NO_ERROR);
		}
	else
		{
		*phWnd = hWndSaved;
		return(1); // ??
		}
	}

/***************************************************************************/
long SYSAPI MDTDialogProc
					(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
	{
	int		Idx;
    UINT 	fRelationship = 0;
	LRESULT RetCode = NO_ERROR;
	LRESULT CallDefWindowProc = NO_ERROR;
	HWND	hWndNext;
    MDTWINDOWINFO *	pWndInfo = NULL;

	for (Idx=0
		; (Idx<Dlg.NumControls) && (hWnd != Dlg.pWndInfo[Idx].hWnd)
		; Idx++)
		{
		}

	if (Idx > Dlg.NumControls)
		{
		pWndInfo = NULL;
		}
	else
		{
		pWndInfo = &(Dlg.pWndInfo[Idx]); // (MDTWINDOWINFO *) GetWindowLong(hWnd, 0);
		}

	if (pWndInfo == NULL)
		{
		RetCode =
			(LRESULT) CallWindowProc ((WNDPROC) Dlg.Parent.Proc
									 , hWnd, message, wParam, lParam);
		}
	else
		{
		if (CallDefWindowProc == NO_ERROR)
			{
			RetCode =
				(LRESULT) CallWindowProc ((WNDPROC) pWndInfo->BaseClass.Proc
										 , hWnd, message, wParam, lParam);
			}
		
		switch (message)
			{
			case WM_SETTEXT:
				PostMessage(hWnd, EM_SETSEL , 1, MAKELONG(-1, -1));
				PostMessage(hWnd, EM_SETSEL , 0, MAKELONG(0, -1));
				break;

			case WM_KEYUP:
				switch (wParam)
					{
					case VK_DOWN:
						fRelationship = GW_HWNDNEXT;
						break;
					case VK_UP:
						fRelationship = GW_HWNDPREV;
						break;
					case VK_TAB:
						{
						int KeyState;
	
						KeyState = GetKeyState(VK_SHIFT);
						if (KeyState < 0)
							fRelationship = GW_HWNDPREV;
						else
							fRelationship = GW_HWNDNEXT;
						break;
						}
					default:
						pWndInfo = NULL;
						break;
					}
	
				//MessageBox(HWND_DESKTOP, "in WM_KEYUP", "ICAPISampleApp"
				//				  , MB_SYSTEMMODAL | MB_OK);
				//
				if (pWndInfo != NULL)
					{
					NextControl(hWnd, &hWndNext, fRelationship, pWndInfo->Class);
					if (hWndNext) { SetFocus(hWndNext); }
					}
	
				break;
			} /* switch */
		} /* else */

	return(RetCode);
	}

/***************************************************************************/
APIRET MDTCreateDlg(HWND hWndParent, MDTDIALOG * pDlg, HINSTANCE hInstance)
	{
	APIRET 	RetCode 		= NO_ERROR;
	int		Idx;

	for (Idx=0; Idx < pDlg->NumControls; Idx++)
		{
		if (pDlg->pWndInfo[Idx].hMem != 0)
			{
			pDlg->pWndInfo[Idx].Value = GlobalLock(pDlg->pWndInfo[Idx].hMem);
			}
		pDlg->pWndInfo[Idx].hWnd =
			CreateWindow( (LPCSTR) 		pDlg->pWndInfo[Idx].Class
						, (LPCSTR) 		pDlg->pWndInfo[Idx].Value
						, (DWORD) 		pDlg->pWndInfo[Idx].Style
						, (int) 		pDlg->pWndInfo[Idx].Rect.left
						, (int) 		pDlg->pWndInfo[Idx].Rect.top
						, (int) 		pDlg->pWndInfo[Idx].Rect.right
						, (int) 		pDlg->pWndInfo[Idx].Rect.bottom
						, (HWND) 	  	hWndParent
						, (HMENU)     	NULL
						, (HINSTANCE) 	hInstance
						, (void far *) 	&(pDlg->pWndInfo[Idx])
						);
		if (pDlg->pWndInfo[Idx].hMem != 0)
			{
			GlobalUnlock(pDlg->pWndInfo[Idx].hMem);
			}

		ShowWindow(pDlg->pWndInfo[Idx].hWnd, SW_SHOW);
		UpdateWindow(pDlg->pWndInfo[Idx].hWnd);

		if (pDlg->WndFocusIdx == Idx)
			{
			SetFocus(pDlg->pWndInfo[Idx].hWnd);
			}

		if ((pDlg->pWndInfo[Idx].Style == WS_EDITSINGLELINE) ||
			(pDlg->pWndInfo[Idx].Style == WS_EDITMULTILINE)		)
			{
			pDlg->pWndInfo[Idx].BaseClass.Proc = (WNDPROC) GetWindowLong (
									pDlg->pWndInfo[Idx].hWnd, GWL_WNDPROC);
			SetWindowLong ( pDlg->pWndInfo[Idx].hWnd, GWL_WNDPROC
						  , (LONG) MDTDialogProc);
			}
		}

	pDlg->Parent.Proc = (WNDPROC) GetWindowLong (hWndParent, GWL_WNDPROC);
//	SetWindowLong (hWndParent, GWL_WNDPROC, (LONG) MDTDialogProc);

	return(RetCode);
	}

/***************************************************************************/
APIRET InitDlgData(MDTDIALOG * pDlg)
	{
	APIRET 	RetCode = NO_ERROR;
	int	   	Idx;

	for ( Idx = 0
		; (Idx < pDlg->NumControls) && (RetCode == NO_ERROR)
		; Idx++)
		{
		switch (pDlg->pWndInfo[Idx].Style)
			{
			case WS_EDITSINGLELINE:
			case WS_EDITMULTILINE:
				if ((pDlg->pWndInfo[Idx].hMem = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT
									   , MAXSTRLEN))
						   ==NULL)
					{
					MessageBox( HWND_DESKTOP
							  , (LPCSTR) "Unable to allocate global memory"
							  , (LPCSTR) "ICAPISAMPLEAPP (ICAPISMP.EXE)"
							  , MB_SYSTEMMODAL | MB_OK);
					RetCode = 1;
					}
				else
					{
					pDlg->pWndInfo[Idx].MaxLen = MAXSTRLEN;
					}
				break;

			case WS_STATIC:
				pDlg->pWndInfo[Idx].hMem = 0;
				if ((pDlg->pWndInfo[Idx].Value = malloc(50)) == NULL)
					{
					pDlg->pWndInfo[Idx].Value = BadAllocStr;
					MessageBox( HWND_DESKTOP
							  , (LPCSTR) "Unable to allocate local memory"
							  , (LPCSTR) "ICAPISAMPLEAPP (ICAPISMP.EXE)"
							  , MB_SYSTEMMODAL | MB_OK);
					RetCode = 1;
					}
				pDlg->pWndInfo[Idx].MaxLen = 50;
				break;
			} /* switch */
		} /* for */

	return(RetCode);
	}

/***************************************************************************/
APIRET FreeDlgData(MDTDIALOG * pDlg)
	{
	APIRET 	RetCode = NO_ERROR;
	int	   	Idx;

	for (Idx = 0; (Idx < (BASEEDIT+NUMEDIT)); Idx++)
		{
		#if 0
			{
			static char TmpStr[100];
			sprintf(TmpStr, "About to free: %d=%p"
					, pDlg->pWndInfo[Idx].hMem, pDlg->pWndInfo[Idx].Value);
			MessageBox( HWND_DESKTOP
					  , (LPCSTR) TmpStr
					  , (LPCSTR) "ICAPISAMPLEAPP (ICAPISMP.EXE)"
					  , MB_SYSTEMMODAL | MB_OK);
			}
			#endif
		if (pDlg->pWndInfo[Idx].hMem != 0)
			{
			GlobalFree(pDlg->pWndInfo[Idx].hMem);
			}
		//else if (pDlg->pWndInfo[Idx].Value != NULL)
		//	{
		//	free(pDlg->pWndInfo[Idx].Value);
		//	}
		pDlg->pWndInfo[Idx].hMem  = 0;
		pDlg->pWndInfo[Idx].Value = NULL;
		}

	return(RetCode);
	}

/***************************************************************************/
APIRET CreateMainWindow(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
	{
	APIRET 	RetCode;

	if (hWnd || message || wParam || lParam) { }

	if ((RetCode = InitDlgData(&Dlg)) == NO_ERROR)
		{
		RetCode = MDTCreateDlg(hWnd, &Dlg, GhInst);
		}

	return(RetCode);
	}

/****************************************************************************
*
*   FUNCTION: MainWndProc(HWND, unsigned, WORD, LONG)
*
*   PURPOSE:  Processes messages
*
****************************************************************************/

long SYSAPI MainWndProc(HWND hWnd
                                    ,UINT message
									,WPARAM wParam
									,LPARAM lParam
									)
	{
	int			Idx;
	WPICAPIRET 	RetCode = NO_ERROR;
	char		TmpStr[50];

    switch (message)
		{
		case WM_CREATE:
			if ((RetCode = CreateMainWindow(hWnd, message, wParam, lParam))
						== NO_ERROR)
				{
				PostMessage(hWnd, WM_COMMAND, (WPARAM) MN_OBJECTDEFAULTS, 0L);
				}
			else
				{
				SendMessage(hWnd, WM_CLOSE, 0, 0L);
				}
			break;

		case WM_COMMAND:

			if (!((wParam >= MN_FIRST) && (wParam <= MN_LAST)))
				{
				RetCode = DefWindowProc(hWnd, message, wParam, lParam);
				}
			else
				{
				/*-----------------------------------------------------------
				* This is one of our menu commands, i.e.
				* MN_FIRST <= wParam <= MN_LAST
				*----------------------------------------------------------*/
				RetCode = WPICAPI_NO_ERROR;
				for (Idx=0; Idx<BASEEDIT+NUMEDIT; Idx++)
					{
					if (Dlg.pWndInfo[Idx].hMem != 0)
						{
						Dlg.pWndInfo[Idx].Value = GlobalLock(Dlg.pWndInfo[Idx].hMem);
						}
					SendMessage(Dlg.pWndInfo[Idx].hWnd, WM_GETTEXT
								, (WPARAM) Dlg.pWndInfo[Idx].MaxLen
								, (LPARAM) Dlg.pWndInfo[Idx].Value);
					#if 0
						MessageBox( HWND_DESKTOP
								  , (LPCSTR) Dlg.pWndInfo[Idx].Value
								  , (LPCSTR) "ICAPISAMPLEAPP (ICAPISMP.EXE)"
								  , MB_SYSTEMMODAL | MB_OK);
						#endif

					}

				/*-----------------------------------------------------------
				* Clear all the prompts and input values.  We will set
				* them below for each specific request.
				*----------------------------------------------------------*/
				if ((wParam >= MN_DEFAULTSFIRST) && (wParam <= MN_DEFAULTSLAST))
					{
					for (Idx=0; Idx<Dlg.NumControls; Idx++)
						{
						lstrcpy(Dlg.pWndInfo[Idx].Value, "");
						}
					SetFocus(Dlg.pWndInfo[0].hWnd);
					}

				lstrcpy(Dlg.pWndInfo[PROMPTRC].Value, "Return Code:");
				lstrcpy(Dlg.pWndInfo[RCVALUE].Value, "");
				SendMessage(Dlg.pWndInfo[RCVALUE].hWnd, WM_SETTEXT
							, (WPARAM) 0
							, (LPARAM) Dlg.pWndInfo[RCVALUE].Value);
	
				switch (wParam)
					{
					case MN_IBASEDEFAULTS:
						lstrcpy(Dlg.pWndInfo[PROMPT1].Value, "iBaseName:");
						lstrcpy(Dlg.pWndInfo[PROMPT2].Value, "Password:");
						lstrcpy(Dlg.pWndInfo[EDIT3  ].Value, "if applicable");
						RetCode = WPICiBaseGetCurrent(Dlg.pWndInfo[EDIT1].Value);
						break;
	
					case MN_OBJECTDEFAULTS:
						lstrcpy(Dlg.pWndInfo[PROMPT1].Value, "CategoryName:");
						lstrcpy(Dlg.pWndInfo[PROMPT3].Value, "ObjectName:");
						lstrcpy(Dlg.pWndInfo[PROMPT5].Value, "ObjectID:");
						lstrcpy(Dlg.pWndInfo[PROMPT6].Value, "NumFound:");
						lstrcpy(Dlg.pWndInfo[PROMPT7].Value, "FieldNames");
						lstrcpy(Dlg.pWndInfo[PROMPT8].Value, "FieldValues:");
						lstrcpy(Dlg.pWndInfo[EDIT1  ].Value, "Person");
						break;
	
					case MN_CONNECTIONDEFAULTS:
						lstrcpy(Dlg.pWndInfo[PROMPT1].Value, "Category1:");
						lstrcpy(Dlg.pWndInfo[PROMPT2].Value, "Category2:");
						lstrcpy(Dlg.pWndInfo[PROMPT3].Value, "PrimaryRelationship:");
						lstrcpy(Dlg.pWndInfo[PROMPT4].Value, "SecondaryRelationship:");
						lstrcpy(Dlg.pWndInfo[PROMPT5].Value, "ObjectID Primary/Secondary");
						lstrcpy(Dlg.pWndInfo[PROMPT6].Value, "ConnectionID");
						lstrcpy(Dlg.pWndInfo[PROMPT7].Value, "FieldNames:");
						lstrcpy(Dlg.pWndInfo[PROMPT8].Value, "FieldValues:");
						lstrcpy(Dlg.pWndInfo[EDIT1  ].Value, "Person");
						lstrcpy(Dlg.pWndInfo[EDIT2  ].Value, "Person");
						lstrcpy(Dlg.pWndInfo[EDIT3  ].Value, "Husband");
						lstrcpy(Dlg.pWndInfo[EDIT4  ].Value, "Wife");
						break;
	
					case MN_GROUPWISEDEFAULTS:
						lstrcpy(Dlg.pWndInfo[PROMPT1].Value, "ImportAppts (0 or 1):");
						lstrcpy(Dlg.pWndInfo[PROMPT2].Value, "ImportTasks (0 or 1):");
						lstrcpy(Dlg.pWndInfo[PROMPT3].Value, "ExportAppts (0 or 1):");
						lstrcpy(Dlg.pWndInfo[PROMPT4].Value, "ExportTasks (0 or 1):");
						lstrcpy(Dlg.pWndInfo[PROMPT5].Value, "Days Prior and After:");
						lstrcpy(Dlg.pWndInfo[EDIT1  ].Value, "1");
						lstrcpy(Dlg.pWndInfo[EDIT2  ].Value, "1");
						lstrcpy(Dlg.pWndInfo[EDIT3  ].Value, "1");
						lstrcpy(Dlg.pWndInfo[EDIT4  ].Value, "1");
						lstrcpy(Dlg.pWndInfo[EDIT5  ].Value, "10");
						lstrcpy(Dlg.pWndInfo[EDIT6  ].Value, "10");
						lstrcpy(Dlg.pWndInfo[EDIT7  ].Value, "^Prior               ^After");
						break;
	
					case MN_MACRODEFAULTS:
						lstrcpy(Dlg.pWndInfo[PROMPT1].Value, "MacroName:");
						lstrcpy(Dlg.pWndInfo[PROMPT2].Value, "Target (optional)");
						lstrcpy(Dlg.pWndInfo[EDIT8  ].Value
						, "The macro will be executed with the following flag: "
						  "WPIC_MACROEXECUTE_FOCUSTOWPIC = 1");
						break;
	
					case MN_SHELLOBJECTDEFAULTS:
						lstrcpy(Dlg.pWndInfo[PROMPT1].Value, "iBaseName (optional):");
						lstrcpy(Dlg.pWndInfo[PROMPT2].Value, "PrinterName (optional):");
						lstrcpy(Dlg.pWndInfo[PROMPT3].Value, "IC Start Parms (optional):");
						break;

					case MN_SHELLSTARTIC:
						RetCode = WPICInfoCentralStart(
										WPIC_MACROEXECUTE_FOCUSTOAPP
									   ,Dlg.pWndInfo[EDIT3].Value);
						break;

					case MN_IBASEINFO :
						RetCode = WPICShellObject(IC_IBASE_INFORMATION
												 ,Dlg.pWndInfo[EDIT1].Value
										         ,Dlg.pWndInfo[EDIT2].Value);
						break;

					case  MN_IBASEBACKUP:
						RetCode = WPICShellObject(IC_IBASE_BACKUP
										         ,Dlg.pWndInfo[EDIT1].Value
										         ,Dlg.pWndInfo[EDIT2].Value);
						break;

					case  MN_IBASERESTORE:
						RetCode = WPICShellObject(IC_IBASE_RESTORE
										         ,Dlg.pWndInfo[EDIT1].Value
										         ,Dlg.pWndInfo[EDIT2].Value);
						break;

					case MN_MACROEXECUTE:
						RetCode = WPICMacroExecute( Dlg.pWndInfo[EDIT1].Value
												  , WPIC_MACROEXECUTE_FOCUSTOWPIC);
						break;
	
					case  MN_MACROEDIT:
						RetCode = WPICShellObject(IC_MACRO_EDIT
										         ,Dlg.pWndInfo[EDIT1].Value
												 ,"");
						break;

					case  MN_MACROCOMPILE:
						RetCode = WPICShellObject(IC_MACRO_COMPILE
										         ,Dlg.pWndInfo[EDIT1].Value
												 ,"");
						break;

					case  MN_MACRODELETE:
						RetCode = WPICShellObject(IC_MACRO_DELETE
										         ,Dlg.pWndInfo[EDIT1].Value
												 ,"");
						break;

					case  MN_MACROCOPY:
						RetCode = WPICShellObject(IC_MACRO_COPY
										         ,Dlg.pWndInfo[EDIT1].Value
										         ,Dlg.pWndInfo[EDIT2].Value);
						break;

					case  MN_MACROMOVE:
						RetCode = WPICShellObject(IC_MACRO_MOVE
										         ,Dlg.pWndInfo[EDIT1].Value
										         ,Dlg.pWndInfo[EDIT2].Value);
						break;

					case MN_IBASEOPEN:
						RetCode = WPICiBaseOpen( Dlg.pWndInfo[EDIT1].Value
											   , Dlg.pWndInfo[EDIT2].Value);
						break;
	
					case MN_IBASESAVE         :
						RetCode = WPICiBaseSave();
						break;
	
					case MN_IBASEGETCURRENT:
						RetCode = WPICiBaseGetCurrent(Dlg.pWndInfo[EDIT1].Value);
						break;
	
					case MN_CATEGORYINFOGET   :
						RetCode = WPICCategoryInfoGet(Dlg.pWndInfo[EDIT1].Value, Dlg.pWndInfo[EDIT8].Value);
						break;
	
					case MN_CONNNECTIONINFOGET:
						RetCode = WPICConnectionInfoRead(Dlg.pWndInfo[EDIT7].Value, Dlg.pWndInfo[EDIT8].Value);
						break;
	
					case MN_GROUPWISEIMPORTEXPORT :
						{
						RetCode = WPICGroupWiseImportExport(
										  Dlg.pWndInfo[EDIT5].Value
										, Dlg.pWndInfo[EDIT6].Value
										, Dlg.pWndInfo[EDIT1     ].Value
										, Dlg.pWndInfo[EDIT2     ].Value
										, Dlg.pWndInfo[EDIT3    ].Value
										, Dlg.pWndInfo[EDIT4    ].Value);
						//sprintf(TmpStr, "RetCode from WPICGroupWise... = %d", RetCode);
						//
						//MessageBox( HWND_DESKTOP
						//		  , (LPCSTR) TmpStr
						//		  , (LPCSTR) "ICAPISAMPLEAPP (ICAPISMP.EXE)"
						//		  , MB_SYSTEMMODAL | MB_OK);
						break;
						}
	
					case MN_OBJECTREAD   	    :
						if ((RetCode = WPICObjectLocate( Dlg.pWndInfo[EDIT1].Value
													   , Dlg.pWndInfo[EDIT3].Value
													   , Dlg.pWndInfo[EDIT7].Value
													   , Dlg.pWndInfo[EDIT9].Value))
									== WPICAPI_NO_ERROR)
							{
							if ((RetCode = WPICTokenGet(Dlg.pWndInfo[EDIT9].Value
													   , (char far *) "1"
													   , Dlg.pWndInfo[EDIT5].Value))
										== WPICAPI_NO_ERROR)
								{
								RetCode = WPICObjectRead(Dlg.pWndInfo[EDIT5].Value
														, Dlg.pWndInfo[EDIT8].Value
														, Dlg.pWndInfo[EDIT9].Value);
								}
							}
						break;
	
					case MN_OBJECTREADTOFILE    :
						/*-----------------------------------------------------
						* Specify an APIFileName so WPICAPI will place the
						* objects found in a file rather than in a field.
						*----------------------------------------------------*/
						if (((RetCode = WPICSettings(Settings.Delimiter
													,APIFILENAME
													,WPICAPI_MAX_STRING_LENGTH_STR))
									 == WPICAPI_NO_ERROR) &&
	
							((RetCode = WPICObjectLocate( Dlg.pWndInfo[EDIT1].Value
														, Dlg.pWndInfo[EDIT3].Value
														, Dlg.pWndInfo[EDIT7].Value
														, Dlg.pWndInfo[EDIT9].Value))
									 == WPICAPI_NO_ERROR))
							{
							/*-------------------------------------------------
							* Use the APIFileName for the parameter ObjectID
							* on WPICObjectRead.
							*------------------------------------------------*/
							if ((RetCode = WPICObjectRead( ""
														 , Dlg.pWndInfo[EDIT8].Value
														 , Dlg.pWndInfo[EDIT9].Value))
										== WPICAPI_NO_ERROR)
								{
								sprintf(Dlg.pWndInfo[EDIT9].Value
									   ,"Objects are in the file: %s"
									   ,APIFILENAME);
								}
		
							}
							WPICSettings(Settings.Delimiter
										,""
										,WPICAPI_MAX_STRING_LENGTH_STR);

						break;
	
					case MN_OBJECTUPDATE 	    :
						RetCode = WPICObjectUpdate(Dlg.pWndInfo[EDIT5].Value, Dlg.pWndInfo[EDIT9].Value);
						break;
	
					case MN_OBJECTADD    	    :
						RetCode = WPICObjectAdd(Dlg.pWndInfo[EDIT1].Value, Dlg.pWndInfo[EDIT9].Value, Dlg.pWndInfo[EDIT5].Value);
						break;
	
					case MN_CONNECTIONREAD :
						/*-----------------------------------------------------
						* First locate all connections matching the connection
						* search information provided in the dialog.
						*----------------------------------------------------*/
						if ((RetCode = WPICConnectionLocate(
											Dlg.pWndInfo[EDIT1].Value
										  , Dlg.pWndInfo[EDIT2].Value
										  , Dlg.pWndInfo[EDIT3].Value
										  , Dlg.pWndInfo[EDIT4].Value
										  , Dlg.pWndInfo[EDIT5].Value
										  , Dlg.pWndInfo[EDIT9].Value
										  , Dlg.pWndInfo[EDIT7].Value))
									 == WPICAPI_NO_ERROR)
							{
							/*-------------------------------------------------
							* Retrieve the first Connection ID, from the list
							* of Connection IDs found.
							*------------------------------------------------*/
							if ((RetCode = WPICTokenGet(
											  Dlg.pWndInfo[EDIT7].Value
											, (char far *) "1" // first one
											, Dlg.pWndInfo[EDIT7].Value))
										== WPICAPI_NO_ERROR)
								{
								/*---------------------------------------------
								* Extract the Object IDs of the two connected
								* objects.  A connection ID happens to be in
								* the format:  ObjectID  + Escape char   +
								*              ObjectID2 + Escape char   +
								*			   AdditionalLinkInformation
								*--------------------------------------------*/
								strcpy(Settings.Delimiter, ESCCHAR);
								if ((RetCode = WPICSettingsEx(&Settings))
											== WPICAPI_NO_ERROR)
									{
									RetCode = WPICTokenGet(
												  Dlg.pWndInfo[EDIT7].Value
												, (char far *) "1"
												, Dlg.pWndInfo[EDIT5].Value);
									RetCode = WPICTokenGet(
													  Dlg.pWndInfo[EDIT7].Value
													, (char far *) "2"
													, Dlg.pWndInfo[EDIT6].Value);
	
									/*-----------------------------------------
									* Change the settings back to the defaults.
									*----------------------------------------*/
									strcpy(Settings.Delimiter, DELIMITER);
									WPICSettingsEx(&Settings);
	
									/*-----------------------------------------
									* Now actually read the connection
									* information.
									*----------------------------------------*/
									RetCode = WPICConnectionRead(
												  Dlg.pWndInfo[EDIT7].Value
												, Dlg.pWndInfo[EDIT8].Value
												, Dlg.pWndInfo[EDIT9].Value);
									}
								}
							}
						break;
	
					case MN_CONNECTIONUPDATE  :
						RetCode = WPICConnectionUpdate( Dlg.pWndInfo[EDIT7].Value
													  , Dlg.pWndInfo[EDIT9].Value);
						break;
	
					case MN_CONNECTIONADD     :
						RetCode = WPICConnectionAdd( Dlg.pWndInfo[EDIT5].Value
												   , Dlg.pWndInfo[EDIT6].Value
												   , Dlg.pWndInfo[EDIT3].Value
												   , Dlg.pWndInfo[EDIT4].Value
												   , Dlg.pWndInfo[EDIT9].Value
												   , Dlg.pWndInfo[EDIT7].Value);
						break;
	
					case MN_EXIT:
						SendMessage(hWnd, WM_CLOSE, 0, 0L);
						break;

					} /* switch */

				if (!((wParam >= MN_DEFAULTSFIRST) &&
					  (wParam <= MN_DEFAULTSLAST)    ))
					{
					/*-----------------------------------------------------
					* Display the return code from the last operation.
					* Except for the exclusions in the if statement above.
					*----------------------------------------------------*/
					if (RetCode == WPICAPI_NO_ERROR)
						{
						sprintf(TmpStr, "%d  (Success)", RetCode);
						}
					else
						{
						WPICAPIRET	RetCode2;
						WPICErrorGetLast(&RetCode2);
						sprintf(TmpStr, "%d - %d  (Failure)", RetCode, RetCode2);
						}
	
					lstrcpy(Dlg.pWndInfo[RCVALUE].Value, TmpStr);

//					MessageBox( HWND_DESKTOP
//							  , (LPCSTR) TmpStr
//							  , (LPCSTR) "ICAPISAMPLEAPP (ICAPISMP.EXE)"
//							  , MB_SYSTEMMODAL | MB_OK);
					}

				/*---------------------------------------------------------
				* Set all the display fields from the Dlg structure
				*--------------------------------------------------------*/
				for (Idx = 0 /* BASEEDIT*/; Idx < (BASEEDIT+NUMEDIT); Idx++)
					{
					SendMessage(Dlg.pWndInfo[Idx].hWnd, WM_SETTEXT
								, (WPARAM) 0
								, (LPARAM) Dlg.pWndInfo[Idx].Value);
					if (Dlg.pWndInfo[Idx].hMem != 0)
						{
						GlobalUnlock(Dlg.pWndInfo[Idx].hMem);
						}
					#if 0
						MessageBox( HWND_DESKTOP
								  , (LPCSTR) Dlg.pWndInfo[Idx].Value
								  , (LPCSTR) "ICAPISAMPLEAPP (ICAPISMP.EXE)"
								  , MB_SYSTEMMODAL | MB_OK);
						#endif
					}
	
				} /* MN_FIRST <= wParam <= MN_LAST */
            break; /* WM_COMMAND */

		case WM_CLOSE:
            /*-------------------------------------------------------------
			* User requested to close the application.
			* DefWindowProc will invoke DestroyWindow.
            *------------------------------------------------------------*/
			FreeDlgData(&Dlg);
			RetCode = DefWindowProc(hWnd, message, wParam, lParam);
			PostQuitMessage(0);
			break;

		case WM_QUIT :
            /*-------------------------------------------------------------
			* Sent as a response to the PostQuitMessage.
            *------------------------------------------------------------*/
			RetCode = DefWindowProc(hWnd, message, wParam, lParam);
			break;

        default      :
            RetCode = DefWindowProc(hWnd, message, wParam, lParam);
			break;

		} /* switch */

	return(RetCode);
	}

/***************************************************************************/

